//date08-11-51
//code by wink99_th
//Modify OutThai code from  my friend "Khun NewBiz" at webboard www.thainin.com
//http://en.wikipedia.org/wiki/Bresenhams_line_algorithm

#include <nds.h>
#include<string.h>
#include<math.h>

#include "ThaiFont.dat"		
#include "bg.h"


u16* video_buffer =  (u16*)BG_BMP_RAM(10);		// Main Screen
u16* video_buffer_sub =  (u16*)BG_BMP_RAM_SUB(0);		// Sub Screen

// ¹ش Шش
void PutPixel(int  x, int  y, int r, int g, int b)
{
   video_buffer_sub [x+(256*y)] = RGB15(r,g,b) | BIT(15);
}



//¹ѡ÷е
void OutCharXY(unsigned char ch,int x,int y,int r, int g,int b)
{
	int k,j;
	
	for(k=0;k<16;k++)
      for(j=0;j<8;j++)
		
	      if  (  ThaiFont[ch][k]   &  (1<<j)  )             PutPixel(x+(8-j),y+k,r,g,b);
   
}

//Ǩͺк  ҧ 
int IsNoCol(unsigned char ch){
   switch(ch)
	   {
      //                                                    
      case 209:case 212:case 213:case 214:case 215:case 216:case 217:
      //                                                    
      case 218:case 219:case 231:case 232:case 233:case 234:case 235:
      //            
      case 236:case 237:return 1;
      default : return 0;
       }
}

//Ǩͺз˹
int IsToneMark(unsigned char ch){
    switch(ch)
	{
       //                               
       case 232: case 233: case 234: case 235:
       //   
       case 236:
	   return 1;
      }
    return 0;
}

//Ǩͺк
int IsAbove(unsigned char ch)
{
   switch(ch)
	 {
      //                               
      case 209: case 212: case 213: case 214:
      //                               
      case 215: case 231: case 232: case 233:
      //                               
      case 234: case 235: case 236: case 237:
	 return 1;
      }
   return 0;
 }

//ѡ
void OutThai(unsigned char *text, int x0,int y0,int r, int g ,int b)
{
	int  i;
	int  dx=0,dy=0;
	int  x=x0, y = y0;
	int counttext=0,countrow=0;
            
	for(i=0; i<strlen(text); i++)
		{
                    if(counttext==37){x=x0; y+=16; counttext=0; countrow++;}
					dx = 9-FontSpace[text[i]];
					x= x-dx;
					if(IsNoCol(text[i])) x=x-9; else counttext++;
					if(IsToneMark(text[i]) && IsAbove(text[i-1]))		dy = 4; 
			
					OutCharXY(text[i], x, y-dy, r, g, b);
					dy = 0;
					x=x+9;
					dx=0;
			


		} // end For 

 }//end  OutThai

void PlotPixel(int row, int col, int r, int g, int b)
{
     video_buffer [col+(256*row)] = RGB15(r,g,b) | BIT(15);

}

 void Plot(int  x, int  y, int r, int g, int b)
{ int i,j;
   for(i=x-1;i<=x+1;i++)
	   for(j=y-1;j<=y+1;j++)
            video_buffer [i+(256*j)] = RGB15(r,g,b) | BIT(15);
   }

void swap(int *px, int *py)
{
	int temp;
	temp = *px;
	*px = *py;
	*py = temp;
}

void Line(int x0, int y0, int x1, int y1, int r, int g, int b)
{
     int x;
	 bool steep = abs(y1 - y0) > abs(x1 - x0);
     if (steep)
	    {  swap(&x0, &y0);
            swap(&x1, &y1);
	    }
	 if (x0 > x1)
	   { swap(&x0, &x1);
         swap(&y0, &y1);
	   }
	 int deltax = x1 - x0;
     int deltay = abs(y1 - y0);
     int error = deltax / 2;
     int ystep;
     int y = y0;
     
	 if (y0 < y1) 
		  ystep = 1; 
     else ystep = -1;
     
	 for (x= x0;x <= x1;x++)
	   { 
	     if (steep)
		    Plot(y,x,r,g,b);
		 else 
		    Plot(x,y,r,g,b);

         error = error - deltay;
         if (error < 0)
	        {
             y = y + ystep;
             error = error + deltax;
	         }
        }//end for(x= x0;x <= x1;x++)
}// end void Line

void clearScr()
{int i,j;
  for (i=80;i<=159 ;i++ )
	  for(j=48;j<=143;j++)
            PlotPixel(j,i,0,0,0);
}

int main(void)
{
	touchPosition touch;
    int held;
	int pressed;
	int Prv_px , Prv_py;

	int stX, stY, w , h;
	stX = 80;
	stY = 48;
	w = 79;
	h = 95;

	powerON( POWER_LCD | POWER_2D_B );
	irqInit();
    irqSet(IRQ_VBLANK, 0);
    irqEnable(IRQ_VBLANK);

    videoSetMode(MODE_5_2D | DISPLAY_BG2_ACTIVE | DISPLAY_BG3_ACTIVE);	   //駤 Mode ʴ Main Screen  Mode 5  Backgroud 3 ʴ
	//videoSetMode(MODE_5_2D |  DISPLAY_BG3_ACTIVE);	   //駤 Mode ʴ Main Screen  Mode 5  Backgroud 3 ʴ

	videoSetModeSub(MODE_5_2D | DISPLAY_BG3_ACTIVE);  //駤 Mode ʴ Sub Screen  Mode 5  Backgroud 3 ʴ
 
	vramSetBankA(VRAM_A_MAIN_BG_0x06000000); // 駤 Vram ͧ Main Screen
    vramSetBankB(VRAM_B_MAIN_BG_0x06020000); // 駤 Vram ͧ Main Screen
	vramSetBankC(VRAM_C_SUB_BG_0x06200000);  //  駤 Vram ͧ Sub Screen
   
   //駤 BackGround 2 ͧ Main Screen
	BACKGROUND.control[2] = BG_BMP16_256x256 | BG_BMP_BASE(0)|BG_PRIORITY(3);
	BACKGROUND.bg2_rotation.xdy = 0;
	BACKGROUND.bg2_rotation.xdx = 1 << 8;
	BACKGROUND.bg2_rotation.ydx = 0;
	BACKGROUND.bg2_rotation.ydy = 1 << 8;
 
  //駤 BackGround 3 ͧ Main Screen
	BACKGROUND.control[3] = BG_BMP16_256x256 | BG_BMP_BASE(10)|BG_PRIORITY(0);
	
	BACKGROUND.bg3_rotation.xdy = 0;
	BACKGROUND.bg3_rotation.xdx = 1 << 8;
	BACKGROUND.bg3_rotation.ydx = 0;
	BACKGROUND.bg3_rotation.ydy = 1 << 8;

	//駤 BackGround 3 ͧ Sub Screen
	BACKGROUND_SUB.control[3] = BG_BMP16_256x256 | BG_BMP_BASE(0)|BG_PRIORITY(3);
	
	BACKGROUND_SUB.bg3_rotation.xdy = 0;
	BACKGROUND_SUB.bg3_rotation.xdx = 1 << 8;
	BACKGROUND_SUB.bg3_rotation.ydx = 0;
	BACKGROUND_SUB.bg3_rotation.ydy = 1 << 8;


    dmaCopyHalfWords(3, bgBitmap,  (uint16 *) BG_BMP_RAM(0), bgBitmapLen); // Copy background  Main Screen  
   
    lcdSwap();

    OutThai("ͧ function  Touch Screen",50,50,20,20,20);

    Prv_px = -1; 
    while(1) 
		{
		 swiWaitForVBlank();
		 scanKeys();
	      touch=touchReadXY();
  		  pressed = keysDown();
		  held = keysHeld();	

		 if ( !(held & KEY_TOUCH) || touch.x == 0 || touch.y == 0)  { continue;}
			
		 if (pressed & KEY_TOUCH)
			{  Prv_px =  -1;
		     }

		 if ( (held & KEY_TOUCH ) && ( touch.px >= stX ) && (touch.px <= stX +w) &&   ( touch.py >= stY ) && (touch.py <= stY +h))
			{    
		     if (Prv_px ==-1 ) 
					{ Prv_px =  touch.px;
		               Prv_py = touch.py;
    	   			   Plot( touch.px, touch.py,31,31,31);
					}

				 else
				   {   Line(Prv_px,Prv_py,touch.px,touch.py,31,31,31);
                       Prv_px =  touch.px;
		               Prv_py = touch.py;
				   }
	
			}// end 		 if(held & KEY_TOUCH )

		 //Ǩͺá OK
		 if ( (held & KEY_TOUCH ) && ( touch.px >= 192 ) && (touch.px <= 240) &&   ( touch.py >= 78 ) && (touch.py <= 113))
            {
			 	clearScr();

			}
          
	    } //end   while(1) 

	return 0;
}



